Global bmpfnt_inputtimer=MilliSecs()
Global bmpfnt_inputtimer_rate = 500
Global bmpfnt_inputtimer_rateb = 500

; Constants for the BMPInput function
Const BMPFNT_NONE = 0
Const BMPFNT_VISIBLE = 1
Const BMPFNT_BLINKING = 2

Type bmpfont
	Field img
	Field x[255],y[255],width[255],height[255]
	Field extrachar
	Field extendedchar
End Type


Function LoadBMPFont(filename$,loadPNG=0)
	; Note -- Do not include the extension of the filename.
	;		  If the image is a PNG instead of a BMP file,
	;		  then set loadPNG to 1
	
	If loadpng Then ext$ = "png" Else ext$="bmp"
	fnt.bmpfont = New bmpfont
	fnt\img = LoadImage(filename+"."+ext)
	f=ReadFile(filename+".ftd")
	fntbackr = ReadByte(f)
	fntbackg = ReadByte(f)
	fntbackb = ReadByte(f)
	intchk = ReadInt(f)
	If intchk=-1 Then
		sillystring$ = ReadString(f)
		For i=1 To 16
			tmp = ReadByte(f)
		Next
		intchk=ReadInt(f)
	End If
	MaskImage fnt\img,fntbackr,fntbackg,fntbackb
		For i=Asc(" ") To Asc("z")
			If i=Asc(" ") Then fnt\x[i]=intchk Else fnt\x[i]=ReadInt(f)
			fnt\y[i]=ReadInt(f)
			fnt\width[i]=ReadInt(f)
			fnt\height[i]=ReadInt(f)
		Next
		If Eof(f)=0 Then
			fnt\extrachar=1
			For i=Asc("z")+1 To 126
				fnt\x[i]=ReadInt(f)
				fnt\y[i]=ReadInt(f)
				fnt\width[i]=ReadInt(f)
				fnt\height[i]=ReadInt(f)
			Next
		End If
		If Eof(f)=0 Then
			fnt\extendedchar=1
			For i=127 To 255
				fnt\x[i]=ReadInt(f)
				fnt\y[i]=ReadInt(f)
				fnt\width[i]=ReadInt(f)
				fnt\height[i]=ReadInt(f)
			Next
		End If
	CloseFile f
	Return Handle(fnt)
End Function

Function BMPText(bmpfnt,x#,y#,txt$,h_align=0,v_align=0,width=0)
	; x,y		- coordinates
	; txt$		- Text to display on the screen
	; h_align	- should text be horizontally centred?
	; v_align	- should text be vertically centred?
	; width		- if greater than 0, text is wrapped to that width
	
	; This function returns the total height of the BMPtext which
	; is useful if you want to set other values like window heights
	; to the height of the text as it wraps.
	
	; If you wish to retrieve the height without drawing text, then see
	; the BMPTextHeight command
	
	Local xx#,yy#
	
	fnt.bmpfont = Object.bmpfont(bmpfnt)
	flines=fnt\height[Asc("X")]
	maxasc=122+4*fnt\extrachar+(255-126)*fnt\extendedchar
	If width>0
		txt=txt+" "
		i=0 ww=0
		While Instr(txt," ",i+1)>0
			For j=i+1 To Instr(txt," ",i+1)
				a=Asc(Mid(txt,j,1))
				If a=>Asc(" ") And a<=maxasc
					ww=ww+fnt\width[a]
				ElseIf a=13
					j=j+1
					flines=flines+fnt\height[Asc("X")]
					ww=0 w=0
					Exit
				End If
				If ww+fnt\width[a]=>width And w>0 Then
					txt = Left(txt,i-1) + Chr(13) + Right(txt,Len(txt)-i)
					ww=0 w=0 flines=flines+fnt\height[Asc("X")]
					j=i+1
				End If
			Next
			i=j-1
			w=ww
		Wend
		i=0 txt=Left(txt,Len(txt)-1)+Chr(13)
		If v_align Then y = y - flines/2
		xx = x  yy = y
		While Instr(txt,Chr(13),i+1)>0
			If h_align
				For j=i+1 To Instr(txt,Chr(13),i+1)-1
					a=Asc(Mid(txt,j,1))
					If a=>Asc(" ") And a<=maxasc Then xx=xx-fnt\width[a]*.5
				Next
			End If
			For j=i+1 To Instr(txt,Chr(13),i+1)-1
				a=Asc(Mid(txt,j,1))
				If a=>Asc(" ") And a<=maxasc
					DrawImageRect fnt\img,xx,yy,fnt\x[a],fnt\y[a],fnt\width[a],fnt\height[a]
					xx=xx+fnt\width[a]
				End If
			Next
			i=j
			yy=yy+fnt\height[Asc("X")] xx=x
		Wend
	Else
		If h_align
			For i=1 To Len(txt)
				a=Asc(Mid(txt,i,1))
				If a=>Asc(" ") And a<=maxasc
					x=x-fnt\width[a]/2
				End If
			Next
		End If
		If v_align y=y-flines/2
			
		;	For i=1 To (Len(txt)>1)
		;		a=Asc(Mid(txt,i,1))
		;		If a=>Asc(" ") And a<=122
		;			y=y-fnt\height[a]/2*flines
		;		End If
		;	Next
		;End If
		xx=x yy=y
		For i=1 To Len(txt)
			a=Asc(Mid(txt,i,1))
			If a=13
				xx=x yy=yy+fnt\height[Asc("X")]
			ElseIf a=>Asc(" ") And a<=maxasc
				DrawImageRect fnt\img,xx,yy,fnt\x[a],fnt\y[a],fnt\width[a],fnt\height[a]
				xx=xx+fnt\width[a]
			End If
		Next
	End If
	
	Return flines
End Function

Function BMPTextHeight(bmpfnt,txt$,width,linesonly=0)
	; txt$		- Text to display on the screen
	; width		- width to constrain the wrapped text to
	; linesonly - returned value is the number of lines, not pixels
	
	; Returns the height (in pixels) that wrapped text will take up.
	; To return merely the number of lines, set "linesonly" to True.
	
	fnt.bmpfont = Object.bmpfont(bmpfnt)
	flines=1
	
	txt=txt+" "
	i=0 ww=0
	maxasc=122+3*fnt\extrachar+(255-126)*fnt\extendedchar
	
	While Instr(txt," ",i+1)>0
		For j=i+1 To Instr(txt," ",i+1)
			a=Asc(Mid(txt,j,1))
			If a=>Asc(" ") And a<=maxasc
				ww=ww+fnt\width[a]
			ElseIf a=13
				j=j+1
				flines=flines+1
				ww=0 w=0
				Exit
			End If
			If ww+fnt\width[a]=>width And w>0 Then
				txt = Left(txt,i-1) + Chr(13) + Right(txt,Len(txt)-i)
				ww=0 w=0 flines=flines+1
				j=i+1
			End If
		Next
		i=j-1
		w=ww
	Wend
	If linesonly
		Return flines
	Else
		Return flines*fnt\height[Asc("X")]
	End If
End Function


Function FreeBMPFont(bmpfnt)
	fnt.bmpfont = Object.bmpfont(bmpfnt)
	FreeImage fnt\img
	Delete fnt
End Function


Function BMPFontHeight(bmpfnt)
	fnt.bmpfont = Object.bmpfont(bmpfnt)
	Return fnt\height[Asc("X")]
End Function


Function BMPStringWidth(bmpfnt,txt$)
	fnt.bmpfont = Object.bmpfont(bmpfnt)
	maxasc=122+4*fnt\extrachar+(255-126)*fnt\extendedchar
	For i=1 To Len(txt)
		a=Asc(Mid(txt,i,1))
		If a=>Asc(" ") And a<=maxasc
			w=w+fnt\width[a]
		End If
	Next
	Return w
End Function

Function BMPInput$(bmpfnt,x,y,txt$,answer$,maxlength=0,cursormk=BMPFNT_BLINKING)
	; bmpfnt    = Font to use for the Input box
	; x, y      = Position
	; txt$      = Question text eg: "Name: "
	; answer$   = The string to put the answer into
	; maxlength = The max number of characters to input
	; cursormk  = BMPFNT_NONE, BMPFNT_VISIBLE, BMPFNT_BLINKING
	
	; Example:  name$ = BMPInput(myfont, 0, 0, "What is your name? ", name$, 15, 1)
	
	; Note: If txt$="" then no text will be drawn, the function will merely input answer$ from
	;       the user's keypresses, without drawing it to the screen.
	
	If MilliSecs() > bmpfnt_inputtimer + bmpfnt_inputtimer_rate+bmpfnt_inputtimer_rateb Then bmpfnt_inputtimer=MilliSecs()
	
	bmp_k=GetKey()
	If bmp_k>31 And bmp_k<127 And (maxlength=0 Or Len(answer)<maxlength) Then
		answer$ = answer$ + Chr(bmp_k)
	End If
	If bmp_k=8 And Len(answer)>0 Then answer=Left(answer,Len(answer)-1)
	
	If txt$<>"" Then BMPText bmpfnt,x,y,txt$ + answer$
	
	; Draw line at the end
	If cursormk=1 Or (cursormk=2 And MilliSecs()<bmpfnt_inputtimer+bmpfnt_inputtimer_Rate)
		Line x+BMPStringwidth(bmpfnt, txt$ + answer$), y, x+BMPStringwidth(bmpfnt, txt$ + answer$), y+BMPFontHeight(bmpfnt)
	End If
	
	Return answer$
End Function

Function SetBMPInputCursorRate(valon,valoff=-1)
	If valoff<0 valoff=valon
	bmpfnt_inputtimer_rate = valon
	bmpfnt_inputtimer_rateb = valoff
End Function

